<?
# Необходимые константы - заполните их своими данными
define('YANDEX_SHOP_ID','YourShopIdHere'); // ID магазина
define('YANDEX_PASSWORD','YourPasswordHere'); // Пароль
define('YANDEX_CERTIFICATE',$_SERVER['DOCUMENT_ROOT'].'/bitrix/php_interface/include/yandex_certificate/certificate.cer'); // Полный путь к файлу с сертификатом (имя файла не важно)
define('YANDEX_PRIVATE_KEY',$_SERVER['DOCUMENT_ROOT'].'/bitrix/php_interface/include/yandex_certificate/private.key'); // Полный путь к файлу с приватным ключом (имя файла не важно)
define('PAYMENT_CARD',2); // ID платежной системы с оплатой по карте

# Функция для подтверждения платежа
function OrderConfirmPayment($OrderID){
	if($OrderID>0 && CModule::IncludeModule('sale')){
		$arOrder = CSaleOrder::GetByID($OrderID);
		if(is_array($arOrder) && $arOrder['ID']>0) {
			$YaKassa = new CWD_YandexKassa(YANDEX_SHOP_ID, YANDEX_CERTIFICATE, YANDEX_PRIVATE_KEY, YANDEX_PASSWORD);
			if(is_object($YaKassa)) {
				$OrderID = $OrderID;
				$OrderSumm = $arOrder['PRICE'];
				$TransactionID = $YaKassa->GetTransactionID($OrderID);
				if($TransactionID) {
					if ($YaKassa->ConfirmPayment($TransactionID, $OrderSumm)) {
						return true;
					}
				}
			}
		}
	}
	return false;
}

# Функция для отмены платежа
function OrderCancelPayment($OrderID){
	if($OrderID>0 && CModule::IncludeModule('sale')){
		$arOrder = CSaleOrder::GetByID($OrderID);
		if(is_array($arOrder) && $arOrder['ID']>0) {
			$YaKassa = new CWD_YandexKassa(YANDEX_SHOP_ID, YANDEX_CERTIFICATE, YANDEX_PRIVATE_KEY, YANDEX_PASSWORD);
			if(is_object($YaKassa)) {
				$OrderID = $OrderID;
				$OrderSumm = $arOrder['PRICE'];
				$TransactionID = $YaKassa->GetTransactionID($OrderID);
				if($TransactionID) {
					if ($YaKassa->CancelPayment($TransactionID, $OrderSumm)) {
						return true;
					}
				}
			}
		}
	}
	return false;
}

# Обработчик события для смены статуса заказа
AddEventHandler('sale','OnSaleBeforeStatusOrder','OnSaleBeforeStatusOrderHandler');
function OnSaleBeforeStatusOrderHandler($OrderID, $Status){
	if($OrderID>0) {
		$arOrder = CSaleOrder::GetByID($OrderID);
		if(is_array($arOrder)) {
			switch($Status){
				case 'F': // "Доставлен"
					if($arOrder['PAY_SYSTEM_ID']==PAYMENT_CARD) {
						if(!self::OrderConfirmPayment($OrderID)){
							return false;
						}
					}
					break;
				case 'C': // "Отменен"
					if($arOrder['PAY_SYSTEM_ID']==PAYMENT_CARD) {
						if(!self::OrderCancelPayment($OrderID)){
							return false;
						}
					}
					break;
			}
		}
	}
	return true;
}

?>